// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef BHV_DRIBBLE_H
#define BHV_DRIBBLE_H

#include <rcsc/player/soccer_action.h>
#include "WorldModel.h"

enum DribbleT 
{
	DRIBBLE_SLOW,
	DRIBBLE_FAST,
	DRIBBLE_WITHBALL,
	DRIBBLE_ILLEGAL
};


class Bhv_Dribble
    : public rcsc::SoccerBehavior {

private:
     double ang;
     DribbleT dribbleT ;
     WorldModelHighLevel WM;
public:

     Bhv_Dribble()
     {
     }

     bool execute( rcsc::PlayerAgent * agent );

     int sign( double x );

     double getDribbleAngle( PlayerAgent * agent );

     DribbleT getDribbleType( PlayerAgent * agent );

     void dribble( PlayerAgent * agent ,
                    double angle = 0.0 ,
                    DribbleT DT = DRIBBLE_WITHBALL ,
                    int numberDash = 3 );

     bool doLongDribble( rcsc::PlayerAgent * agent );


};

#endif
