// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef BHV_MARK_CLOSE_OPPONENT_H
#define BHV_MARK_CLOSE_OPPONENT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <rcsc/geom/vector_2d.h>
#include <rcsc/player/soccer_action.h>

#include "bhv_basic_tackle.h"
#include "bhv_basic_move.h"

#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_scan_field.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/action/body_turn_to_point.h>

#include "strategy.h"
#include <rcsc/formation/formation.h>

#include "body_go_to_point_2009.h"

#include "WorldModel.h"

namespace rcsc {

class Bhv_MarkCloseOpponent
    : public rcsc::SoccerBehavior {
private:
    const rcsc::Vector2D M_home_pos;

public:
    Bhv_MarkCloseOpponent( const rcsc::Vector2D & home_pos )
        : M_home_pos( home_pos )
      { }

    bool execute( rcsc::PlayerAgent * agent );

    Vector2D get_extra_point( PlayerAgent * agent , Vector2D mark_point );
};

}
#endif
