// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef ROBOSAMPAD_BHV_MARK_OPPONENT_H
#define ROBOSAMPAD_BHV_MARK_OPPONENT_H

#include "strategy.h"

#include <rcsc/geom/vector_2d.h>

#include <rcsc/formation/formation.h>

#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_scan_field.h>
#include <rcsc/action/body_go_to_point.h>
#include "body_go_to_point_2009.h"
#include <rcsc/action/neck_turn_to_point.h>
#include <rcsc/action/body_turn_to_point.h>
#include <rcsc/action/body_turn_to_ball.h>

#include <rcsc/player/player_agent.h>

#include <rcsc/common/server_param.h>

#include "bhv_set_play.h"
#include "bhv_basic_move.h"
#include "bhv_set_play_kick_in.h"
#include "bhv_set_play_free_kick.h"

#include "WorldModel.h"


using namespace rcsc;
static bool S_stop_move;

class Bhv_MarkOpponent
      : SoccerBehavior {

private:
    Vector2D   home_pos;
    int        S_last_mark_time;
public:
    Bhv_MarkOpponent( Vector2D M_home_pos ,
                      int      M_last_time )
      : home_pos( M_home_pos )
      , S_last_mark_time( M_last_time )
    {
    }

    bool execute( PlayerAgent * agent );
private:
/*!
   \brief update positions and so do mark.
   \param agent : world model and ... using
   \return true or false
*/
/*----------------------------------------*/
    void doWait( PlayerAgent * agent );
/*!
   \brief do mark opponent when opponent position is known.
   \param agent : world model and ... using
   \return true or false
*/
/*----------------------------------------*/
    bool doMark( PlayerAgent * agent );
/*!
   \brief do move to home_pos when opponent position is unknown
   \param agent : world model and ... using
   \return true or false
*/
/*----------------------------------------*/
    void doMove( PlayerAgent * agent );

    const
    PlayerObject * mark_opponent( PlayerAgent * agent );
};

#endif
