// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef ROBOSAMPAD_BHV_OFFENSIVE_MOVE_H
#define ROBOSAMPAD_BHV_OFFENSIVE_MOVE_H

#include <rcsc/geom/vector_2d.h>
#include <rcsc/player/soccer_action.h>

#include "bhv_basic_tackle.h"
#include "neck_offensive_intercept_neck.h"
#include "body_forestall_block.h"
#include <rcsc/action/bhv_go_to_point_look_ball.h>

#include <rcsc/action/basic_actions.h>
#include <rcsc/action/body_go_to_point.h>
#include <rcsc/action/body_intercept.h>
#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>
#include <rcsc/player/intercept_table.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>

#include "neck_check_ball_owner.h"
#include "WorldModel.h"


class Bhv_OffensiveMove
    : public rcsc::SoccerBehavior {
private:
    const rcsc::Vector2D M_home_pos;
    const bool M_turn_at;
    const bool M_turn_neck;

public:
    Bhv_OffensiveMove( const rcsc::Vector2D & home_pos,
                       const bool turn_at = true,
                       const bool turn_neck = true )
                     : M_home_pos( home_pos )
                     , M_turn_at( turn_at )
                     , M_turn_neck( turn_neck )
    {
    }

    bool execute( rcsc::PlayerAgent * agent );

private:
    double getDashPower( const rcsc::PlayerAgent * agent,
                         const rcsc::Vector2D & target_point );


    bool doForestall( rcsc::PlayerAgent * agent );

    bool doIntercept( rcsc::PlayerAgent * agent );
};

#endif
