// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef MOVE_TO_POS_H
#define MOVE_TO_POS_H

#include <rcsc/action/body_turn_to_point.h>
#include <rcsc/action/body_go_to_point.h>
#include <rcsc/action/neck_turn_to_ball_or_scan.h>

class move_to_pos{
private:
	rcsc::Vector2D move;
	double        d_thr;
	double        dash ;
public:

    move_to_pos( rcsc::Vector2D v , double d_t , double dash_val )
    {
	move = v;
	d_thr = d_t;
	dash = dash_val;
    }


    ~move_to_pos()
    {}
//-----------------------------------

void execute( rcsc::PlayerAgent * agent )
{

	if ( ! rcsc::Body_GoToPoint( move,
				     d_thr,
				     dash  ).execute( agent ) )
	{
		rcsc::AngleDeg body_angle = agent->world().ball().angleFromSelf();
		if ( body_angle.degree() < 0.0 ) body_angle -= 90.0;
		else body_angle += 90.0;
	
		rcsc::Vector2D body_point = agent->world().self().pos();
		body_point += rcsc::Vector2D::polar2vector( 10.0, body_angle );
	
		rcsc::Body_TurnToPoint( body_point ).execute( agent );
	}

		agent->setNeckAction( new rcsc::Neck_TurnToBallOrScan() );
}
//-----------------------------------
};

#endif
