// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA, Hidehisa AKIYAMA
 Modified Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef NECK_DEFAULT_INTERCEPT_NECK_H
#define NECK_DEFAULT_INTERCEPT_NECK_H

#include <rcsc/player/soccer_action.h>

#include <rcsc/action/neck_turn_to_point.h>
#include <rcsc/action/neck_turn_to_ball_and_player.h>
#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/view_wide.h>
#include <rcsc/action/view_normal.h>
#include <rcsc/action/view_synch.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/intercept_table.h>
#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>
#include <rcsc/action/body_pass.h>



namespace rcsc {
class PlayerAgent;
class ViewAction;
}

class Neck_DefaultInterceptNeck
    : public rcsc::NeckAction {
private:
    rcsc::ViewAction * M_default_view_act;
    rcsc::NeckAction * M_default_neck_act;

public:

    explicit
    Neck_DefaultInterceptNeck( rcsc::ViewAction * view = static_cast< rcsc::ViewAction * >( 0 ),
                               rcsc::NeckAction * neck = static_cast< rcsc::NeckAction * >( 0 ) )
        : M_default_view_act( view )
        , M_default_neck_act( neck )
      { }

    explicit
    Neck_DefaultInterceptNeck( rcsc::NeckAction * neck = static_cast< rcsc::NeckAction * >( 0 ) )
        : M_default_view_act( static_cast< rcsc::ViewAction * >( 0 ) )
        , M_default_neck_act( neck )
      { }

   ~Neck_DefaultInterceptNeck()
   {
	if ( M_default_view_act )
	{
		delete M_default_view_act;
		M_default_view_act = static_cast< rcsc::ViewAction * >( 0 );
	}
	
	if ( M_default_neck_act )
	{
		delete M_default_neck_act;
		M_default_neck_act = static_cast< rcsc::NeckAction * >( 0 );
	}
   }


    bool execute( rcsc::PlayerAgent * agent );

    rcsc::NeckAction * clone() const;

private:

    bool doTurnToReceiver( rcsc::PlayerAgent * agent );
};


#endif
