// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA
 Modified Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef NECK_OFFENSIVE_INTERCEPT_NECK_H
#define NECK_OFFENSIVE_INTERCEPT_NECK_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <rcsc/player/soccer_action.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>
#include <rcsc/player/player_agent.h>
#include <rcsc/player/intercept_table.h>

#include <rcsc/action/neck_turn_to_point.h>
#include <rcsc/action/neck_turn_to_ball_and_player.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>
#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_turn_to_goalie_or_scan.h>
#include <rcsc/action/view_wide.h>
#include <rcsc/action/view_normal.h>
#include <rcsc/action/view_synch.h>

#include "neck_default_intercept_neck.h"


namespace rcsc {
class PlayerAgent;
class ViewAction;
}

using namespace rcsc;

class Neck_OffensiveInterceptNeck
    : public rcsc::NeckAction {
public:

    Neck_OffensiveInterceptNeck()
    { }

    bool execute( rcsc::PlayerAgent * agent );

    rcsc::NeckAction * clone() const
    {
          return new Neck_OffensiveInterceptNeck();
    }
};

#endif
