// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA
 Modified Copyright (C) Hossein Mobasher

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef AGENT2D_ROLE_SIDE_FORWARD_H
#define AGENT2D_ROLE_SIDE_FORWARD_H

#include "soccer_role.h"

namespace rcsc {
class AngleDeg;
class Vector2D;
class PlayerAgent;
class Formation;
}

class RoleSideForward
    : public SoccerRole {
private:

public:

    explicit
    RoleSideForward( boost::shared_ptr< const rcsc::Formation > f )
        : SoccerRole( f )
      { }

    ~RoleSideForward()
      { }

    virtual
    void execute( rcsc::PlayerAgent * agent );

    static
    std::string name()
      {
          return std::string( "SideForward" );
      }

    static
    SoccerRole * create( boost::shared_ptr< const rcsc::Formation > f )
      {
          return ( new RoleSideForward( f ) );
      }


private:

    void doKick( rcsc::PlayerAgent * agent );

    void doMove( rcsc::PlayerAgent * agent );

    bool doLongDribble( rcsc::PlayerAgent * agent );

    void doCrossAreaKick( rcsc::PlayerAgent* agent );

    bool isOppGoalieInRect( rcsc::PlayerAgent * agent , int iSide );

    void doDribbleAttackAreaKick( rcsc::PlayerAgent* agent );

    void doShootAreaMove( rcsc::PlayerAgent * agent,
                          const rcsc::Vector2D & home_pos );

    double getShootAreaMoveDashPower( rcsc::PlayerAgent * agent,
                                      const rcsc::Vector2D & target_point );

    rcsc::Vector2D getShootAreaMoveTarget( rcsc::PlayerAgent * agent,
                                           const rcsc::Vector2D & home_pos );

    bool  doDribbleShootArea( rcsc::PlayerAgent * agent );
};


#endif
